package com.localmatters;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import javax.xml.namespace.QName;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
 *
 * @author Daniel Cavalcanti
 */
public class Driver {
    
    public static void main(String[] args)
    throws Exception {
        
        URL wsdl = new URL("http://collector.isxinc.com/ProducerWSService/ProducerWS?wsdl");
        QName qname = new QName("http://producer.collector.flexiq.localmatters.com/", "ProducerWSService");
        
        System.out.println("Establishing port to WS.");
        ProducerWSService service = new ProducerWSService(wsdl, qname);
        ProducerWS port = service.getProducerWSPort();
        
        System.out.println("Generating WS parameters.");
        
        String username = "guest";
        String password = "guest";
        
        List<byte[]> msgs = new ArrayList<byte[]>();
        msgs.add(load());
        
        System.out.println("Sending message.");
        port.send(msgs, username, password);
        
    }
    
    private static byte[] load()
    throws Exception {
        
        final String resource = "collector-message.xml";
        InputStream is = Driver.class.getClassLoader().getResourceAsStream(resource);
        
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer transformer = tf.newTransformer();
        
        StreamSource ss = new StreamSource(is);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        StreamResult sr = new StreamResult(baos);
        
        transformer.transform(ss, sr);
        baos.close();
        
        System.out.println(new String(baos.toByteArray()));
        return baos.toByteArray();
        
    }
    
    
}
